/*
 ****************************************************************************
 *
 *                   "DHRYSTONE" Benchmark Program
 *                   -----------------------------
 *
 *  Version:    C, Version 2.1
 *
 *  File:       dhry.h (part 1 of 3)
 *
 *  Date:       May 25, 1988
 *
 *  Author:     Reinhold P. Weicker
 *                      Siemens AG, E STE 35
 *                      Postfach 3240
 *                      8520 Erlangen
 *                      Germany (West)
 *                              Phone:  [xxx-49]-9131-7-20330
 *                                      (8-17 Central European Time)
 *                              Usenet: ..!mcvax!unido!estevax!weicker
 *
 *              Original Version (in Ada) published in
 *              "Communications of the ACM" vol. 27., no. 10 (Oct. 1984),
 *              pp. 1013 - 1030, together with the statistics
 *              on which the distribution of statements etc. is based.
 *
 *              In this C version, the following C library functions are used:
 *              - strcpy, strcmp (inside the measurement loop)
 *              - printf, scanf (outside the measurement loop)
 *              In addition, Berkeley UNIX system calls "times ()" or "time ()"
 *              are used for execution time measurement. For measurements
 *              on other systems, these calls have to be changed.
 *
 *  Collection of Results:
 *              Reinhold Weicker (address see above) and
 *
 *              Rick Richardson
 *              PC Research. Inc.
 *              94 Apple Orchard Drive
 *              Tinton Falls, NJ 07724
 *                      Phone:  (201) 389-8963 (9-17 EST)
 *                      Usenet: ...!uunet!pcrat!rick
 ***************************************************************************/

/* Compiler and system dependent definitions: */

#define Mic_secs_Per_Second     1000000.0
					 /* Berkeley UNIX C returns process times in seconds/HZ */
#define structassign(d, s)      d = s

typedef       enum    {Ident_1, Ident_2, Ident_3, Ident_4, Ident_5}
	      Enumeration;
		  /* for boolean and enumeration types in Ada, Pascal */

/* General definitions: */

#include <stdio.h> 
#include <string.h>   /* for strcpy, strcmp */
#include <stdlib.h>
#include <time.h>

#define true  1
#define false 0

typedef int     One_Thirty;
typedef int     One_Fifty;
typedef char    Capital_Letter;
typedef int     Boolean;
typedef char    Str_30 [31];
typedef int     Arr_1_Dim [50];
typedef int     Arr_2_Dim [50] [50];

typedef struct record
	 {
	 struct record *Ptr_Comp;
	 Enumeration    Discr;
	 union {
			 struct {
						Enumeration Enum_Comp;
						int         Int_Comp;
						char        Str_Comp [31];
						} var_1;
			 struct {
						Enumeration E_Comp_2;
						char        Str_2_Comp [31];
						} var_2;
			 struct {
						char        Ch_1_Comp;
						char        Ch_2_Comp;
						} var_3;
			 } variant;
		} Rec_Type, *Rec_Pointer;


